%%%%% LOAD TRAJECTORY XTC [xtc_water, tElapsed] = parseXtc('mdnojump_water.xtc')

trajectory=xtc_water.coords(1:820,:,:); %% 1 till 160 = relevant atoms

donor_list=[2 14];
acceptor_list =[13 16 1];
O1_atom=1;
N1_atom=13;
n_offset=20;
n_molecules=41; %number of molecules

atom_donor=[];
molecule_donor=[];
for i=1:length(donor_list)
	atom_donor=[atom_donor, donor_list(i):n_offset:(n_offset*n_molecules)];
	molecule_donor=[molecule_donor, 1:n_molecules];
end

atom_acceptor=[];
molecule_acceptor=[];
for i=1:length(acceptor_list)
	atom_acceptor=[atom_acceptor, acceptor_list(i):n_offset:(n_offset*n_molecules)];
	molecule_acceptor=[molecule_acceptor, 1:n_molecules];
end

O1_atom=O1_atom:n_offset:(n_offset*n_molecules);
N1_atom=N1_atom:n_offset:(n_offset*n_molecules);

n_don=length(atom_donor);
n_acc=length(atom_acceptor);


distvec=zeros(n_don,n_acc,10001);
hbond_detect=[];
hbond_molecule=[];

for i=1:n_don
    
    for j=1:n_acc
        for k=1:10000
            distvec(i,j,k)=norm(trajectory(atom_donor(i),:,k)-trajectory(atom_acceptor(j),:,k))*10;
            if (distvec(i,j,k)<2.5 && molecule_donor(i)~=molecule_acceptor(j))
                hbond_detect=[hbond_detect;[atom_donor(i),atom_acceptor(j),k]];
                hbond_molecule=[hbond_molecule;[molecule_donor(i),molecule_acceptor(j),k]];
            end
        end
    end
end
%save hbond_detect.txt hbond_detect -ascii
%save hbond_molecule.txt hbond_molecule -ascii

O_N_angle=zeros(size(hbond_detect,1),1);
for i=1:size(hbond_detect,1)
    coor_O1= trajectory(O1_atom(hbond_molecule(i,1)),:,hbond_detect(i,3))';
    coor_N1= trajectory(N1_atom(hbond_molecule(i,1)),:,hbond_detect(i,3))';
    coor_O2= trajectory(O1_atom(hbond_molecule(i,2)),:,hbond_detect(i,3))';
    coor_N2= trajectory(N1_atom(hbond_molecule(i,2)),:,hbond_detect(i,3))';
    x1=(coor_O1-coor_N1); x2=(coor_O2-coor_N2);
    O_N_angle(i)=acos((x1'*x2)/(norm(x1)*norm(x2)))/pi*180;
end
hist(O_N_angle)
sum(abs(O_N_angle-90)<45)/size(hbond_detect,1)
%saveas(Figure1,Chcl3_MeoH_0.5.tif)
%save 0.7c_eth_meth_0.1_O_N_angle.txt O_N_angle -ascii
%step=5224; [atom_donor(hbond_detect(find(hbond_detect(:,3)==step),1))',atom_acceptor(hbond_detect(find(hbond_detect(:,3)==step),2))']